# BMA400 Sensor API

> This repository contains Bosch Sensortec's BMA400 accelerometer sensor API

## Sensor Overview
The BMA400 is the first real ultra-low power acceleration sensor without compromising on performance. Featuring 12-bit digital resolution, continuous measurement and a defined selectable bandwidth combined with ultra-low power the BMA400 allows low-noise measurement of accelerations in three perpendicular axes. The BMA400 thus senses tilt, orientation, tab/double tab, and enables plug 'n' play step counting with activity recognition especially suited for wearable devices, which need a long-lasting battery lifetime. Thanks to the continuous measurement principle and always-defined bandwidth, the BMA400 is the ideal solution for smart home applications such as smart indoor climate systems and smart home security systems. In the latter, the BMA400 can distinguish between real alarm situations like broken glass and false signals coming from random vibrations. Thereby, the new acceleration sensor avoids false alarms.

#### Applications

- IoT and smart home applications (e.g. indoor climate systems, security systems)
- Activity tracking and step counting in wearable devices (e.g. fitness bands, smart and regular watches, hearables)
- Industrial applications (e.g. predictive maintenance, package tracking)
- Power management of consumer end-devices based on motion


For more information refer product page [Link](https://www.bosch-sensortec.com/bst/products/all_products/bma400_1)

# Copyright (C) 2018 Bosch Sensortec GmbH